\begin{exercise}{4.1}
  \begin{figure}[h!]
    \centering
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetFour/ex1/accuracies.pdf}
    \end{subfigure}\hfil
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetFour/ex1/accuracies-zoom.pdf}
    \end{subfigure}
    \caption{
      accuracies for different number of clusters. Figure~(b) shows only low clusters numbers.
      In the case of classes Kmeans, each class has \(\lceil\frac{k}3\rceil\) clusters.
    }
    \label{fig:4.1}
  \end{figure}
  I've implemented 2 \texttt{sklearn} classifier based on Kmeans clustering, which apply the strategies described in the text of the exercise. I've chosen to use 5-fold~cross~validation to estimate the test error since the number of of elements in the dataset is low.
  
  Figures~\ref{fig:4.1} show the results. The classes-clustering performs better at optimal \(k\) and also has better performance at low number of clustering (as one may expect since we are imposing the class separation at training time). For larger values of \(k\) the 2 methods score essentially the same, probably due to the small size of the dataset.
  
  It's interesting to note that when the number of clusters tends to the number of samples, both the algorithm converges to a \texttt{KNN} with \(k=1\). We expect them to reach same accuracy in this regime and so they do as can be seen in Figure~\ref{fig:4.1}~(a).

  \clearpage
  \pythoncode{\RootPathSheetFour/ex1/code.py}
\end{exercise}